#pragma once
#include <SDL_rect.h>

#include "KCollider.h"

namespace KapitanGame {
	class KCircle;

	class KRect final : public KCollider
	{
	public:
		KRect(KObject* parent, const float width, const float height)
			: KCollider(parent),
			Width(width),
			Height(height)
		{
		}
		float GetWidth() const override;
		float GetHeight() const override;
		static KVector2D GetSeparationVector(float left, float right, float top, float bottom);
		bool IsCollision(const KCollider* other) const override;
		KVector2D GetSeparationVector(const KCollider* other) const override;
		KVector2D GetSeparationVector(const SDL_FRect& map) const override;
	private:
		KVector2D GetSeparationVector(const KCircle* other) const;
		KVector2D GetSeparationVector(const KRect* other) const;
		bool IsCollision(const KCircle* other) const;
		float GetLeft() const;
		float GetRight() const;
		float GetBottom() const;
		float GetTop() const;
		bool IsCollision(const KRect* other) const;
		float Width;
		float Height;
	};
}


